import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsFeature {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Title?: string;
  Subtitle?: string;
  Icon?: string;
  Sort!: number;
  Enable!: unknown;
  Type!: number;
  MessageId?: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsFeatureSchema = defineEntity({
  class: ScsFeature,
  comment: '云校特色',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Title: p.string().name('Title').nullable().comment('标题'),
    Subtitle: p.string().name('Subtitle').nullable().comment('副标题'),
    Icon: p.string().name('Icon').nullable().comment('图标'),
    Sort: p.integer().name('Sort').comment('序号'),
    Enable: p.array().name('Enable').comment('启用'),
    Type: p.integer().name('Type').comment('类型(0-特色 1-纯图片 2-板块)'),
    MessageId: p.bigint().name('MessageId').columnType('bigint').nullable().comment('消息Id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
